#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const long long MAXPQ = 2e18;

int n, m;
vector<int> a;
vector<long long> b;

pair<long long, long long> fraction(long long a, long long b) {
    if (a == 0) {
        return {0, 1};
    } else {
        long long d = __gcd(a, b);
        a /= d, b /= d;
        return {a, b};
    }
}

long double check_test(int testnum) {
    int n = inf.readInt();
    int m = inf.readInt();
    for (int i = 0; i < n; ++i) {
        inf.readInt();
    }
    int countOfSuccessful = 0;
    for (int i = 0; i < m; ++i) {
        inf.readLong();
        long long a_jury = ans.readLong(0, MAXPQ), b_jury = ans.readLong(1, MAXPQ);
        long long a_part = ouf.readLong(0, MAXPQ), b_part = ouf.readLong(1, MAXPQ);
        if (fraction(a_jury, b_jury) == fraction(a_part, b_part)) {
            ++countOfSuccessful;
        }
    }
    return (long double)countOfSuccessful * 10 / (long double)m;
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);
    double ans = 0;
    int t = inf.readInt();
    for (int i = 0; i < t; i++) {
        ans += check_test(i + 1);
    }
    printf("%f\n", ans);
    quitf(_ok, "Ok");
}